// A Bison parser, made by GNU Bison 3.7.6.

// Skeleton implementation for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015, 2018-2021 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <https://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.

// DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
// especially those whose name start with YY_ or yy_.  They are
// private implementation details that can be changed or removed.



// First part of user prologue.
#line 31 "src/parser.yy"

#include <iostream>

#include "driver.h"

void yyerror(bpftrace::Driver &driver, const char *s);

#line 49 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"


#include "parser.tab.hh"




#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> // FIXME: INFRINGES ON USER NAME SPACE.
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif


// Whether we are compiled with exception support.
#ifndef YY_EXCEPTIONS
# if defined __GNUC__ && !defined __EXCEPTIONS
#  define YY_EXCEPTIONS 0
# else
#  define YY_EXCEPTIONS 1
# endif
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K].location)
/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

# ifndef YYLLOC_DEFAULT
#  define YYLLOC_DEFAULT(Current, Rhs, N)                               \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).begin  = YYRHSLOC (Rhs, 1).begin;                   \
          (Current).end    = YYRHSLOC (Rhs, N).end;                     \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).begin = (Current).end = YYRHSLOC (Rhs, 0).end;      \
        }                                                               \
    while (false)
# endif


// Enable debugging if requested.
#if YYDEBUG

// A pseudo ostream that takes yydebug_ into account.
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Symbol)         \
  do {                                          \
    if (yydebug_)                               \
    {                                           \
      *yycdebug_ << Title << ' ';               \
      yy_print_ (*yycdebug_, Symbol);           \
      *yycdebug_ << '\n';                       \
    }                                           \
  } while (false)

# define YY_REDUCE_PRINT(Rule)          \
  do {                                  \
    if (yydebug_)                       \
      yy_reduce_print_ (Rule);          \
  } while (false)

# define YY_STACK_PRINT()               \
  do {                                  \
    if (yydebug_)                       \
      yy_stack_print_ ();                \
  } while (false)

#else // !YYDEBUG

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Symbol)  YY_USE (Symbol)
# define YY_REDUCE_PRINT(Rule)           static_cast<void> (0)
# define YY_STACK_PRINT()                static_cast<void> (0)

#endif // !YYDEBUG

#define yyerrok         (yyerrstatus_ = 0)
#define yyclearin       (yyla.clear ())

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)

#line 4 "src/parser.yy"
namespace  bpftrace  {
#line 147 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"

  /// Build a parser object.
   Parser :: Parser  (bpftrace::Driver &driver_yyarg, void *yyscanner_yyarg)
#if YYDEBUG
    : yydebug_ (false),
      yycdebug_ (&std::cerr),
#else
    :
#endif
      driver (driver_yyarg),
      yyscanner (yyscanner_yyarg)
  {}

   Parser ::~ Parser  ()
  {}

   Parser ::syntax_error::~syntax_error () YY_NOEXCEPT YY_NOTHROW
  {}

  /*---------------.
  | symbol kinds.  |
  `---------------*/



  // by_state.
   Parser ::by_state::by_state () YY_NOEXCEPT
    : state (empty_state)
  {}

   Parser ::by_state::by_state (const by_state& that) YY_NOEXCEPT
    : state (that.state)
  {}

  void
   Parser ::by_state::clear () YY_NOEXCEPT
  {
    state = empty_state;
  }

  void
   Parser ::by_state::move (by_state& that)
  {
    state = that.state;
    that.clear ();
  }

   Parser ::by_state::by_state (state_type s) YY_NOEXCEPT
    : state (s)
  {}

   Parser ::symbol_kind_type
   Parser ::by_state::kind () const YY_NOEXCEPT
  {
    if (state == empty_state)
      return symbol_kind::S_YYEMPTY;
    else
      return YY_CAST (symbol_kind_type, yystos_[+state]);
  }

   Parser ::stack_symbol_type::stack_symbol_type ()
  {}

   Parser ::stack_symbol_type::stack_symbol_type (YY_RVREF (stack_symbol_type) that)
    : super_type (YY_MOVE (that.state), YY_MOVE (that.location))
  {
    switch (that.kind ())
    {
      case symbol_kind::S_attach_point: // attach_point
        value.YY_MOVE_OR_COPY< ast::AttachPoint * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_attach_points: // attach_points
        value.YY_MOVE_OR_COPY< ast::AttachPointList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_call: // call
        value.YY_MOVE_OR_COPY< ast::Call * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_primary_expr: // primary_expr
      case symbol_kind::S_postfix_expr: // postfix_expr
      case symbol_kind::S_tuple_access_expr: // tuple_access_expr
      case symbol_kind::S_unary_expr: // unary_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_conditional_expr: // conditional_expr
      case symbol_kind::S_logical_or_expr: // logical_or_expr
      case symbol_kind::S_logical_and_expr: // logical_and_expr
      case symbol_kind::S_or_expr: // or_expr
      case symbol_kind::S_xor_expr: // xor_expr
      case symbol_kind::S_and_expr: // and_expr
      case symbol_kind::S_equality_expr: // equality_expr
      case symbol_kind::S_relational_expr: // relational_expr
      case symbol_kind::S_shift_expr: // shift_expr
      case symbol_kind::S_arith_expr: // arith_expr
      case symbol_kind::S_cast_expr: // cast_expr
      case symbol_kind::S_map_or_var: // map_or_var
        value.YY_MOVE_OR_COPY< ast::Expression * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_vargs: // vargs
        value.YY_MOVE_OR_COPY< ast::ExpressionList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_int: // int
        value.YY_MOVE_OR_COPY< ast::Integer * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_map: // map
        value.YY_MOVE_OR_COPY< ast::Map * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_param: // param
        value.YY_MOVE_OR_COPY< ast::PositionalParameter * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_pred: // pred
        value.YY_MOVE_OR_COPY< ast::Predicate * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_probe: // probe
        value.YY_MOVE_OR_COPY< ast::Probe * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_probes: // probes
        value.YY_MOVE_OR_COPY< ast::ProbeList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_block_stmt: // block_stmt
      case symbol_kind::S_expr_stmt: // expr_stmt
      case symbol_kind::S_jump_stmt: // jump_stmt
      case symbol_kind::S_loop_stmt: // loop_stmt
      case symbol_kind::S_if_stmt: // if_stmt
      case symbol_kind::S_assign_stmt: // assign_stmt
        value.YY_MOVE_OR_COPY< ast::Statement * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_stmt_list: // stmt_list
      case symbol_kind::S_block_or_if: // block_or_if
        value.YY_MOVE_OR_COPY< ast::StatementList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_var: // var
        value.YY_MOVE_OR_COPY< ast::Variable * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unary_op: // unary_op
      case symbol_kind::S_compound_op: // compound_op
        value.YY_MOVE_OR_COPY< int > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_INT: // "integer"
        value.YY_MOVE_OR_COPY< long > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_BUILTIN: // "builtin"
      case symbol_kind::S_CALL: // "call"
      case symbol_kind::S_CALL_BUILTIN: // "call_builtin"
      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_PATH: // "path"
      case symbol_kind::S_CPREPROC: // "preprocessor directive"
      case symbol_kind::S_STRUCT_DEFN: // "struct definition"
      case symbol_kind::S_ENUM: // "enum"
      case symbol_kind::S_STRING: // "string"
      case symbol_kind::S_MAP: // "map"
      case symbol_kind::S_VAR: // "variable"
      case symbol_kind::S_PARAM: // "positional parameter"
      case symbol_kind::S_STACK_MODE: // "stack_mode"
      case symbol_kind::S_c_definitions: // c_definitions
      case symbol_kind::S_attach_point_def: // attach_point_def
      case symbol_kind::S_ident: // ident
        value.YY_MOVE_OR_COPY< std::string > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

#if 201103L <= YY_CPLUSPLUS
    // that is emptied.
    that.state = empty_state;
#endif
  }

   Parser ::stack_symbol_type::stack_symbol_type (state_type s, YY_MOVE_REF (symbol_type) that)
    : super_type (s, YY_MOVE (that.location))
  {
    switch (that.kind ())
    {
      case symbol_kind::S_attach_point: // attach_point
        value.move< ast::AttachPoint * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_attach_points: // attach_points
        value.move< ast::AttachPointList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_call: // call
        value.move< ast::Call * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_primary_expr: // primary_expr
      case symbol_kind::S_postfix_expr: // postfix_expr
      case symbol_kind::S_tuple_access_expr: // tuple_access_expr
      case symbol_kind::S_unary_expr: // unary_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_conditional_expr: // conditional_expr
      case symbol_kind::S_logical_or_expr: // logical_or_expr
      case symbol_kind::S_logical_and_expr: // logical_and_expr
      case symbol_kind::S_or_expr: // or_expr
      case symbol_kind::S_xor_expr: // xor_expr
      case symbol_kind::S_and_expr: // and_expr
      case symbol_kind::S_equality_expr: // equality_expr
      case symbol_kind::S_relational_expr: // relational_expr
      case symbol_kind::S_shift_expr: // shift_expr
      case symbol_kind::S_arith_expr: // arith_expr
      case symbol_kind::S_cast_expr: // cast_expr
      case symbol_kind::S_map_or_var: // map_or_var
        value.move< ast::Expression * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_vargs: // vargs
        value.move< ast::ExpressionList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_int: // int
        value.move< ast::Integer * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_map: // map
        value.move< ast::Map * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_param: // param
        value.move< ast::PositionalParameter * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_pred: // pred
        value.move< ast::Predicate * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_probe: // probe
        value.move< ast::Probe * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_probes: // probes
        value.move< ast::ProbeList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_block_stmt: // block_stmt
      case symbol_kind::S_expr_stmt: // expr_stmt
      case symbol_kind::S_jump_stmt: // jump_stmt
      case symbol_kind::S_loop_stmt: // loop_stmt
      case symbol_kind::S_if_stmt: // if_stmt
      case symbol_kind::S_assign_stmt: // assign_stmt
        value.move< ast::Statement * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_stmt_list: // stmt_list
      case symbol_kind::S_block_or_if: // block_or_if
        value.move< ast::StatementList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_var: // var
        value.move< ast::Variable * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unary_op: // unary_op
      case symbol_kind::S_compound_op: // compound_op
        value.move< int > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_INT: // "integer"
        value.move< long > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_BUILTIN: // "builtin"
      case symbol_kind::S_CALL: // "call"
      case symbol_kind::S_CALL_BUILTIN: // "call_builtin"
      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_PATH: // "path"
      case symbol_kind::S_CPREPROC: // "preprocessor directive"
      case symbol_kind::S_STRUCT_DEFN: // "struct definition"
      case symbol_kind::S_ENUM: // "enum"
      case symbol_kind::S_STRING: // "string"
      case symbol_kind::S_MAP: // "map"
      case symbol_kind::S_VAR: // "variable"
      case symbol_kind::S_PARAM: // "positional parameter"
      case symbol_kind::S_STACK_MODE: // "stack_mode"
      case symbol_kind::S_c_definitions: // c_definitions
      case symbol_kind::S_attach_point_def: // attach_point_def
      case symbol_kind::S_ident: // ident
        value.move< std::string > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

    // that is emptied.
    that.kind_ = symbol_kind::S_YYEMPTY;
  }

#if YY_CPLUSPLUS < 201103L
   Parser ::stack_symbol_type&
   Parser ::stack_symbol_type::operator= (const stack_symbol_type& that)
  {
    state = that.state;
    switch (that.kind ())
    {
      case symbol_kind::S_attach_point: // attach_point
        value.copy< ast::AttachPoint * > (that.value);
        break;

      case symbol_kind::S_attach_points: // attach_points
        value.copy< ast::AttachPointList * > (that.value);
        break;

      case symbol_kind::S_call: // call
        value.copy< ast::Call * > (that.value);
        break;

      case symbol_kind::S_primary_expr: // primary_expr
      case symbol_kind::S_postfix_expr: // postfix_expr
      case symbol_kind::S_tuple_access_expr: // tuple_access_expr
      case symbol_kind::S_unary_expr: // unary_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_conditional_expr: // conditional_expr
      case symbol_kind::S_logical_or_expr: // logical_or_expr
      case symbol_kind::S_logical_and_expr: // logical_and_expr
      case symbol_kind::S_or_expr: // or_expr
      case symbol_kind::S_xor_expr: // xor_expr
      case symbol_kind::S_and_expr: // and_expr
      case symbol_kind::S_equality_expr: // equality_expr
      case symbol_kind::S_relational_expr: // relational_expr
      case symbol_kind::S_shift_expr: // shift_expr
      case symbol_kind::S_arith_expr: // arith_expr
      case symbol_kind::S_cast_expr: // cast_expr
      case symbol_kind::S_map_or_var: // map_or_var
        value.copy< ast::Expression * > (that.value);
        break;

      case symbol_kind::S_vargs: // vargs
        value.copy< ast::ExpressionList * > (that.value);
        break;

      case symbol_kind::S_int: // int
        value.copy< ast::Integer * > (that.value);
        break;

      case symbol_kind::S_map: // map
        value.copy< ast::Map * > (that.value);
        break;

      case symbol_kind::S_param: // param
        value.copy< ast::PositionalParameter * > (that.value);
        break;

      case symbol_kind::S_pred: // pred
        value.copy< ast::Predicate * > (that.value);
        break;

      case symbol_kind::S_probe: // probe
        value.copy< ast::Probe * > (that.value);
        break;

      case symbol_kind::S_probes: // probes
        value.copy< ast::ProbeList * > (that.value);
        break;

      case symbol_kind::S_block_stmt: // block_stmt
      case symbol_kind::S_expr_stmt: // expr_stmt
      case symbol_kind::S_jump_stmt: // jump_stmt
      case symbol_kind::S_loop_stmt: // loop_stmt
      case symbol_kind::S_if_stmt: // if_stmt
      case symbol_kind::S_assign_stmt: // assign_stmt
        value.copy< ast::Statement * > (that.value);
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_stmt_list: // stmt_list
      case symbol_kind::S_block_or_if: // block_or_if
        value.copy< ast::StatementList * > (that.value);
        break;

      case symbol_kind::S_var: // var
        value.copy< ast::Variable * > (that.value);
        break;

      case symbol_kind::S_unary_op: // unary_op
      case symbol_kind::S_compound_op: // compound_op
        value.copy< int > (that.value);
        break;

      case symbol_kind::S_INT: // "integer"
        value.copy< long > (that.value);
        break;

      case symbol_kind::S_BUILTIN: // "builtin"
      case symbol_kind::S_CALL: // "call"
      case symbol_kind::S_CALL_BUILTIN: // "call_builtin"
      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_PATH: // "path"
      case symbol_kind::S_CPREPROC: // "preprocessor directive"
      case symbol_kind::S_STRUCT_DEFN: // "struct definition"
      case symbol_kind::S_ENUM: // "enum"
      case symbol_kind::S_STRING: // "string"
      case symbol_kind::S_MAP: // "map"
      case symbol_kind::S_VAR: // "variable"
      case symbol_kind::S_PARAM: // "positional parameter"
      case symbol_kind::S_STACK_MODE: // "stack_mode"
      case symbol_kind::S_c_definitions: // c_definitions
      case symbol_kind::S_attach_point_def: // attach_point_def
      case symbol_kind::S_ident: // ident
        value.copy< std::string > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    return *this;
  }

   Parser ::stack_symbol_type&
   Parser ::stack_symbol_type::operator= (stack_symbol_type& that)
  {
    state = that.state;
    switch (that.kind ())
    {
      case symbol_kind::S_attach_point: // attach_point
        value.move< ast::AttachPoint * > (that.value);
        break;

      case symbol_kind::S_attach_points: // attach_points
        value.move< ast::AttachPointList * > (that.value);
        break;

      case symbol_kind::S_call: // call
        value.move< ast::Call * > (that.value);
        break;

      case symbol_kind::S_primary_expr: // primary_expr
      case symbol_kind::S_postfix_expr: // postfix_expr
      case symbol_kind::S_tuple_access_expr: // tuple_access_expr
      case symbol_kind::S_unary_expr: // unary_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_conditional_expr: // conditional_expr
      case symbol_kind::S_logical_or_expr: // logical_or_expr
      case symbol_kind::S_logical_and_expr: // logical_and_expr
      case symbol_kind::S_or_expr: // or_expr
      case symbol_kind::S_xor_expr: // xor_expr
      case symbol_kind::S_and_expr: // and_expr
      case symbol_kind::S_equality_expr: // equality_expr
      case symbol_kind::S_relational_expr: // relational_expr
      case symbol_kind::S_shift_expr: // shift_expr
      case symbol_kind::S_arith_expr: // arith_expr
      case symbol_kind::S_cast_expr: // cast_expr
      case symbol_kind::S_map_or_var: // map_or_var
        value.move< ast::Expression * > (that.value);
        break;

      case symbol_kind::S_vargs: // vargs
        value.move< ast::ExpressionList * > (that.value);
        break;

      case symbol_kind::S_int: // int
        value.move< ast::Integer * > (that.value);
        break;

      case symbol_kind::S_map: // map
        value.move< ast::Map * > (that.value);
        break;

      case symbol_kind::S_param: // param
        value.move< ast::PositionalParameter * > (that.value);
        break;

      case symbol_kind::S_pred: // pred
        value.move< ast::Predicate * > (that.value);
        break;

      case symbol_kind::S_probe: // probe
        value.move< ast::Probe * > (that.value);
        break;

      case symbol_kind::S_probes: // probes
        value.move< ast::ProbeList * > (that.value);
        break;

      case symbol_kind::S_block_stmt: // block_stmt
      case symbol_kind::S_expr_stmt: // expr_stmt
      case symbol_kind::S_jump_stmt: // jump_stmt
      case symbol_kind::S_loop_stmt: // loop_stmt
      case symbol_kind::S_if_stmt: // if_stmt
      case symbol_kind::S_assign_stmt: // assign_stmt
        value.move< ast::Statement * > (that.value);
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_stmt_list: // stmt_list
      case symbol_kind::S_block_or_if: // block_or_if
        value.move< ast::StatementList * > (that.value);
        break;

      case symbol_kind::S_var: // var
        value.move< ast::Variable * > (that.value);
        break;

      case symbol_kind::S_unary_op: // unary_op
      case symbol_kind::S_compound_op: // compound_op
        value.move< int > (that.value);
        break;

      case symbol_kind::S_INT: // "integer"
        value.move< long > (that.value);
        break;

      case symbol_kind::S_BUILTIN: // "builtin"
      case symbol_kind::S_CALL: // "call"
      case symbol_kind::S_CALL_BUILTIN: // "call_builtin"
      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_PATH: // "path"
      case symbol_kind::S_CPREPROC: // "preprocessor directive"
      case symbol_kind::S_STRUCT_DEFN: // "struct definition"
      case symbol_kind::S_ENUM: // "enum"
      case symbol_kind::S_STRING: // "string"
      case symbol_kind::S_MAP: // "map"
      case symbol_kind::S_VAR: // "variable"
      case symbol_kind::S_PARAM: // "positional parameter"
      case symbol_kind::S_STACK_MODE: // "stack_mode"
      case symbol_kind::S_c_definitions: // c_definitions
      case symbol_kind::S_attach_point_def: // attach_point_def
      case symbol_kind::S_ident: // ident
        value.move< std::string > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    // that is emptied.
    that.state = empty_state;
    return *this;
  }
#endif

  template <typename Base>
  void
   Parser ::yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const
  {
    if (yymsg)
      YY_SYMBOL_PRINT (yymsg, yysym);
  }

#if YYDEBUG
  template <typename Base>
  void
   Parser ::yy_print_ (std::ostream& yyo, const basic_symbol<Base>& yysym) const
  {
    std::ostream& yyoutput = yyo;
    YY_USE (yyoutput);
    if (yysym.empty ())
      yyo << "empty symbol";
    else
      {
        symbol_kind_type yykind = yysym.kind ();
        yyo << (yykind < YYNTOKENS ? "token" : "nterm")
            << ' ' << yysym.name () << " ("
            << yysym.location << ": ";
        YY_USE (yykind);
        yyo << ')';
      }
  }
#endif

  void
   Parser ::yypush_ (const char* m, YY_MOVE_REF (stack_symbol_type) sym)
  {
    if (m)
      YY_SYMBOL_PRINT (m, sym);
    yystack_.push (YY_MOVE (sym));
  }

  void
   Parser ::yypush_ (const char* m, state_type s, YY_MOVE_REF (symbol_type) sym)
  {
#if 201103L <= YY_CPLUSPLUS
    yypush_ (m, stack_symbol_type (s, std::move (sym)));
#else
    stack_symbol_type ss (s, sym);
    yypush_ (m, ss);
#endif
  }

  void
   Parser ::yypop_ (int n)
  {
    yystack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
   Parser ::debug_stream () const
  {
    return *yycdebug_;
  }

  void
   Parser ::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


   Parser ::debug_level_type
   Parser ::debug_level () const
  {
    return yydebug_;
  }

  void
   Parser ::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif // YYDEBUG

   Parser ::state_type
   Parser ::yy_lr_goto_state_ (state_type yystate, int yysym)
  {
    int yyr = yypgoto_[yysym - YYNTOKENS] + yystate;
    if (0 <= yyr && yyr <= yylast_ && yycheck_[yyr] == yystate)
      return yytable_[yyr];
    else
      return yydefgoto_[yysym - YYNTOKENS];
  }

  bool
   Parser ::yy_pact_value_is_default_ (int yyvalue)
  {
    return yyvalue == yypact_ninf_;
  }

  bool
   Parser ::yy_table_value_is_error_ (int yyvalue)
  {
    return yyvalue == yytable_ninf_;
  }

  int
   Parser ::operator() ()
  {
    return parse ();
  }

  int
   Parser ::parse ()
  {
    int yyn;
    /// Length of the RHS of the rule being reduced.
    int yylen = 0;

    // Error handling.
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// The lookahead symbol.
    symbol_type yyla;

    /// The locations where the error started and ended.
    stack_symbol_type yyerror_range[3];

    /// The return value of parse ().
    int yyresult;

#if YY_EXCEPTIONS
    try
#endif // YY_EXCEPTIONS
      {
    YYCDEBUG << "Starting parse\n";


    /* Initialize the stack.  The initial state will be set in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystack_.clear ();
    yypush_ (YY_NULLPTR, 0, YY_MOVE (yyla));

  /*-----------------------------------------------.
  | yynewstate -- push a new symbol on the stack.  |
  `-----------------------------------------------*/
  yynewstate:
    YYCDEBUG << "Entering state " << int (yystack_[0].state) << '\n';
    YY_STACK_PRINT ();

    // Accept?
    if (yystack_[0].state == yyfinal_)
      YYACCEPT;

    goto yybackup;


  /*-----------.
  | yybackup.  |
  `-----------*/
  yybackup:
    // Try to take a decision without lookahead.
    yyn = yypact_[+yystack_[0].state];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    // Read a lookahead token.
    if (yyla.empty ())
      {
        YYCDEBUG << "Reading a token\n";
#if YY_EXCEPTIONS
        try
#endif // YY_EXCEPTIONS
          {
            symbol_type yylookahead (yylex (driver, yyscanner));
            yyla.move (yylookahead);
          }
#if YY_EXCEPTIONS
        catch (const syntax_error& yyexc)
          {
            YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
            error (yyexc);
            goto yyerrlab1;
          }
#endif // YY_EXCEPTIONS
      }
    YY_SYMBOL_PRINT ("Next token is", yyla);

    if (yyla.kind () == symbol_kind::S_YYerror)
    {
      // The scanner already issued an error message, process directly
      // to error recovery.  But do not keep the error token as
      // lookahead, it is too special and may lead us to an endless
      // loop in error recovery. */
      yyla.kind_ = symbol_kind::S_YYUNDEF;
      goto yyerrlab1;
    }

    /* If the proper action on seeing token YYLA.TYPE is to reduce or
       to detect an error, take that action.  */
    yyn += yyla.kind ();
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yyla.kind ())
      {
        goto yydefault;
      }

    // Reduce or error.
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
        if (yy_table_value_is_error_ (yyn))
          goto yyerrlab;
        yyn = -yyn;
        goto yyreduce;
      }

    // Count tokens shifted since error; after three, turn off error status.
    if (yyerrstatus_)
      --yyerrstatus_;

    // Shift the lookahead token.
    yypush_ ("Shifting", state_type (yyn), YY_MOVE (yyla));
    goto yynewstate;


  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[+yystack_[0].state];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;


  /*-----------------------------.
  | yyreduce -- do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    {
      stack_symbol_type yylhs;
      yylhs.state = yy_lr_goto_state_ (yystack_[yylen].state, yyr1_[yyn]);
      /* Variants are always initialized to an empty instance of the
         correct type. The default '$$ = $1' action is NOT applied
         when using variants.  */
      switch (yyr1_[yyn])
    {
      case symbol_kind::S_attach_point: // attach_point
        yylhs.value.emplace< ast::AttachPoint * > ();
        break;

      case symbol_kind::S_attach_points: // attach_points
        yylhs.value.emplace< ast::AttachPointList * > ();
        break;

      case symbol_kind::S_call: // call
        yylhs.value.emplace< ast::Call * > ();
        break;

      case symbol_kind::S_primary_expr: // primary_expr
      case symbol_kind::S_postfix_expr: // postfix_expr
      case symbol_kind::S_tuple_access_expr: // tuple_access_expr
      case symbol_kind::S_unary_expr: // unary_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_conditional_expr: // conditional_expr
      case symbol_kind::S_logical_or_expr: // logical_or_expr
      case symbol_kind::S_logical_and_expr: // logical_and_expr
      case symbol_kind::S_or_expr: // or_expr
      case symbol_kind::S_xor_expr: // xor_expr
      case symbol_kind::S_and_expr: // and_expr
      case symbol_kind::S_equality_expr: // equality_expr
      case symbol_kind::S_relational_expr: // relational_expr
      case symbol_kind::S_shift_expr: // shift_expr
      case symbol_kind::S_arith_expr: // arith_expr
      case symbol_kind::S_cast_expr: // cast_expr
      case symbol_kind::S_map_or_var: // map_or_var
        yylhs.value.emplace< ast::Expression * > ();
        break;

      case symbol_kind::S_vargs: // vargs
        yylhs.value.emplace< ast::ExpressionList * > ();
        break;

      case symbol_kind::S_int: // int
        yylhs.value.emplace< ast::Integer * > ();
        break;

      case symbol_kind::S_map: // map
        yylhs.value.emplace< ast::Map * > ();
        break;

      case symbol_kind::S_param: // param
        yylhs.value.emplace< ast::PositionalParameter * > ();
        break;

      case symbol_kind::S_pred: // pred
        yylhs.value.emplace< ast::Predicate * > ();
        break;

      case symbol_kind::S_probe: // probe
        yylhs.value.emplace< ast::Probe * > ();
        break;

      case symbol_kind::S_probes: // probes
        yylhs.value.emplace< ast::ProbeList * > ();
        break;

      case symbol_kind::S_block_stmt: // block_stmt
      case symbol_kind::S_expr_stmt: // expr_stmt
      case symbol_kind::S_jump_stmt: // jump_stmt
      case symbol_kind::S_loop_stmt: // loop_stmt
      case symbol_kind::S_if_stmt: // if_stmt
      case symbol_kind::S_assign_stmt: // assign_stmt
        yylhs.value.emplace< ast::Statement * > ();
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_stmt_list: // stmt_list
      case symbol_kind::S_block_or_if: // block_or_if
        yylhs.value.emplace< ast::StatementList * > ();
        break;

      case symbol_kind::S_var: // var
        yylhs.value.emplace< ast::Variable * > ();
        break;

      case symbol_kind::S_unary_op: // unary_op
      case symbol_kind::S_compound_op: // compound_op
        yylhs.value.emplace< int > ();
        break;

      case symbol_kind::S_INT: // "integer"
        yylhs.value.emplace< long > ();
        break;

      case symbol_kind::S_BUILTIN: // "builtin"
      case symbol_kind::S_CALL: // "call"
      case symbol_kind::S_CALL_BUILTIN: // "call_builtin"
      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_PATH: // "path"
      case symbol_kind::S_CPREPROC: // "preprocessor directive"
      case symbol_kind::S_STRUCT_DEFN: // "struct definition"
      case symbol_kind::S_ENUM: // "enum"
      case symbol_kind::S_STRING: // "string"
      case symbol_kind::S_MAP: // "map"
      case symbol_kind::S_VAR: // "variable"
      case symbol_kind::S_PARAM: // "positional parameter"
      case symbol_kind::S_STACK_MODE: // "stack_mode"
      case symbol_kind::S_c_definitions: // c_definitions
      case symbol_kind::S_attach_point_def: // attach_point_def
      case symbol_kind::S_ident: // ident
        yylhs.value.emplace< std::string > ();
        break;

      default:
        break;
    }


      // Default location.
      {
        stack_type::slice range (yystack_, yylen);
        YYLLOC_DEFAULT (yylhs.location, range, yylen);
        yyerror_range[1].location = yylhs.location;
      }

      // Perform the reduction.
      YY_REDUCE_PRINT (yyn);
#if YY_EXCEPTIONS
      try
#endif // YY_EXCEPTIONS
        {
          switch (yyn)
            {
  case 2: // program: c_definitions probes
#line 158 "src/parser.yy"
                                     { driver.root_ = new ast::Program(yystack_[1].value.as < std::string > (), yystack_[0].value.as < ast::ProbeList * > ()); }
#line 1077 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 3: // c_definitions: "preprocessor directive" c_definitions
#line 162 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "\n" + yystack_[0].value.as < std::string > (); }
#line 1083 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 4: // c_definitions: "struct definition" c_definitions
#line 163 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + ";\n" + yystack_[0].value.as < std::string > (); }
#line 1089 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 5: // c_definitions: "enum" c_definitions
#line 164 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + ";\n" + yystack_[0].value.as < std::string > (); }
#line 1095 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 6: // c_definitions: %empty
#line 165 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = std::string(); }
#line 1101 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 7: // probes: probes probe
#line 169 "src/parser.yy"
                             { yylhs.value.as < ast::ProbeList * > () = yystack_[1].value.as < ast::ProbeList * > (); yystack_[1].value.as < ast::ProbeList * > ()->push_back(yystack_[0].value.as < ast::Probe * > ()); }
#line 1107 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 8: // probes: probe
#line 170 "src/parser.yy"
                             { yylhs.value.as < ast::ProbeList * > () = new ast::ProbeList; yylhs.value.as < ast::ProbeList * > ()->push_back(yystack_[0].value.as < ast::Probe * > ()); }
#line 1113 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 9: // probe: attach_points pred block
#line 175 "src/parser.yy"
                {
                  if (!driver.listing_)
                    yylhs.value.as < ast::Probe * > () = new ast::Probe(yystack_[2].value.as < ast::AttachPointList * > (), yystack_[1].value.as < ast::Predicate * > (), yystack_[0].value.as < ast::StatementList * > ());
                  else
                  {
                    error(yylhs.location, "unexpected listing query format");
                    YYERROR;
                  }
                }
#line 1127 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 10: // probe: attach_points "end of file"
#line 185 "src/parser.yy"
                {
                  if (driver.listing_)
                    yylhs.value.as < ast::Probe * > () = new ast::Probe(yystack_[1].value.as < ast::AttachPointList * > (), nullptr, nullptr);
                  else
                  {
                    error(yylhs.location, "unexpected end of file, expected {");
                    YYERROR;
                  }
                }
#line 1141 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 11: // attach_points: attach_points "," attach_point
#line 197 "src/parser.yy"
                                               { yylhs.value.as < ast::AttachPointList * > () = yystack_[2].value.as < ast::AttachPointList * > (); yystack_[2].value.as < ast::AttachPointList * > ()->push_back(yystack_[0].value.as < ast::AttachPoint * > ()); }
#line 1147 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 12: // attach_points: attach_point
#line 198 "src/parser.yy"
                                               { yylhs.value.as < ast::AttachPointList * > () = new ast::AttachPointList; yylhs.value.as < ast::AttachPointList * > ()->push_back(yystack_[0].value.as < ast::AttachPoint * > ()); }
#line 1153 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 13: // attach_point: attach_point_def
#line 202 "src/parser.yy"
                                                { yylhs.value.as < ast::AttachPoint * > () = new ast::AttachPoint(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1159 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 14: // attach_point_def: attach_point_def ident
#line 206 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + yystack_[0].value.as < std::string > (); }
#line 1165 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 15: // attach_point_def: attach_point_def "string"
#line 210 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "\"" + std::regex_replace(yystack_[0].value.as < std::string > (), std::regex("\""), "\\\"") + "\""; }
#line 1171 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 16: // attach_point_def: attach_point_def "path"
#line 211 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + yystack_[0].value.as < std::string > (); }
#line 1177 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 17: // attach_point_def: attach_point_def "integer"
#line 212 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + std::to_string(yystack_[0].value.as < long > ()); }
#line 1183 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 18: // attach_point_def: attach_point_def ":"
#line 213 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + ":"; }
#line 1189 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 19: // attach_point_def: attach_point_def "."
#line 214 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "."; }
#line 1195 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 20: // attach_point_def: attach_point_def "+"
#line 215 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "+"; }
#line 1201 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 21: // attach_point_def: attach_point_def "*"
#line 216 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "*"; }
#line 1207 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 22: // attach_point_def: attach_point_def "["
#line 217 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "["; }
#line 1213 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 23: // attach_point_def: attach_point_def "]"
#line 218 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "]"; }
#line 1219 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 24: // attach_point_def: attach_point_def param
#line 220 "src/parser.yy"
                {
                  if (yystack_[0].value.as < ast::PositionalParameter * > ()->ptype != PositionalParameterType::positional)
                  {
                    error(yylhs.location, "Not a positional parameter");
                    YYERROR;
                  }
                  // "Un-parse" the positional parameter back into text so
                  // we can give it to the AttachPointParser. This is kind of
                  // a hack but there doesn't look to be any other way.
                  yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "$" + std::to_string(yystack_[0].value.as < ast::PositionalParameter * > ()->n);
                  delete yystack_[0].value.as < ast::PositionalParameter * > ();
                }
#line 1236 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 25: // attach_point_def: %empty
#line 232 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = ""; }
#line 1242 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 26: // pred: "/" expr "end predicate"
#line 236 "src/parser.yy"
                                 { yylhs.value.as < ast::Predicate * > () = new ast::Predicate(yystack_[1].value.as < ast::Expression * > (), yylhs.location); }
#line 1248 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 27: // pred: %empty
#line 237 "src/parser.yy"
                                  { yylhs.value.as < ast::Predicate * > () = nullptr; }
#line 1254 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 28: // param: "positional parameter"
#line 242 "src/parser.yy"
                      {
                        try {
                          long n = std::stol(yystack_[0].value.as < std::string > ().substr(1, yystack_[0].value.as < std::string > ().size()-1));
                          if (n == 0) throw std::exception();
                          yylhs.value.as < ast::PositionalParameter * > () = new ast::PositionalParameter(PositionalParameterType::positional, n, yylhs.location);
                        } catch (std::exception const& e) {
                          error(yystack_[0].location, "param " + yystack_[0].value.as < std::string > () + " is out of integer range [1, " +
                                std::to_string(std::numeric_limits<long>::max()) + "]");
                          YYERROR;
                        }
                      }
#line 1270 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 29: // param: "$#"
#line 253 "src/parser.yy"
                           { yylhs.value.as < ast::PositionalParameter * > () = new ast::PositionalParameter(PositionalParameterType::count, 0, yylhs.location); }
#line 1276 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 30: // block: "{" stmt_list "}"
#line 257 "src/parser.yy"
                                      { yylhs.value.as < ast::StatementList * > () = yystack_[1].value.as < ast::StatementList * > (); }
#line 1282 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 31: // stmt_list: expr_stmt ";" stmt_list
#line 264 "src/parser.yy"
                                        { yylhs.value.as < ast::StatementList * > () = yystack_[0].value.as < ast::StatementList * > (); yystack_[0].value.as < ast::StatementList * > ()->insert(yystack_[0].value.as < ast::StatementList * > ()->begin(), yystack_[2].value.as < ast::Statement * > ()); }
#line 1288 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 32: // stmt_list: expr_stmt
#line 265 "src/parser.yy"
                                        { yylhs.value.as < ast::StatementList * > () = new ast::StatementList; yylhs.value.as < ast::StatementList * > ()->push_back(yystack_[0].value.as < ast::Statement * > ()); }
#line 1294 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 33: // stmt_list: block_stmt stmt_list
#line 269 "src/parser.yy"
                                        { yylhs.value.as < ast::StatementList * > () = yystack_[0].value.as < ast::StatementList * > (); yystack_[0].value.as < ast::StatementList * > ()->insert(yystack_[0].value.as < ast::StatementList * > ()->begin(), yystack_[1].value.as < ast::Statement * > ()); }
#line 1300 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 34: // stmt_list: %empty
#line 270 "src/parser.yy"
                                        { yylhs.value.as < ast::StatementList * > () = new ast::StatementList; }
#line 1306 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 35: // block_stmt: loop_stmt
#line 274 "src/parser.yy"
                             { yylhs.value.as < ast::Statement * > () = yystack_[0].value.as < ast::Statement * > (); }
#line 1312 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 36: // block_stmt: if_stmt
#line 275 "src/parser.yy"
                             { yylhs.value.as < ast::Statement * > () = yystack_[0].value.as < ast::Statement * > (); }
#line 1318 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 37: // expr_stmt: expr
#line 279 "src/parser.yy"
                                   { yylhs.value.as < ast::Statement * > () = new ast::ExprStatement(yystack_[0].value.as < ast::Expression * > (), yystack_[0].location); }
#line 1324 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 38: // expr_stmt: jump_stmt
#line 280 "src/parser.yy"
                                   { yylhs.value.as < ast::Statement * > () = yystack_[0].value.as < ast::Statement * > (); }
#line 1330 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 39: // expr_stmt: assign_stmt
#line 285 "src/parser.yy"
                                   { yylhs.value.as < ast::Statement * > () = yystack_[0].value.as < ast::Statement * > (); }
#line 1336 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 40: // jump_stmt: "break"
#line 289 "src/parser.yy"
                         { yylhs.value.as < ast::Statement * > () = new ast::Jump(token::BREAK, yylhs.location); }
#line 1342 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 41: // jump_stmt: "continue"
#line 290 "src/parser.yy"
                         { yylhs.value.as < ast::Statement * > () = new ast::Jump(token::CONTINUE, yylhs.location); }
#line 1348 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 42: // jump_stmt: "return"
#line 291 "src/parser.yy"
                         { yylhs.value.as < ast::Statement * > () = new ast::Jump(token::RETURN, yylhs.location); }
#line 1354 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 43: // loop_stmt: "unroll" "(" int ")" block
#line 295 "src/parser.yy"
                                                     { yylhs.value.as < ast::Statement * > () = new ast::Unroll(yystack_[2].value.as < ast::Integer * > (), yystack_[0].value.as < ast::StatementList * > (), yystack_[4].location + yystack_[1].location); }
#line 1360 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 44: // loop_stmt: "unroll" "(" param ")" block
#line 296 "src/parser.yy"
                                                     { yylhs.value.as < ast::Statement * > () = new ast::Unroll(yystack_[2].value.as < ast::PositionalParameter * > (), yystack_[0].value.as < ast::StatementList * > (), yystack_[4].location + yystack_[1].location); }
#line 1366 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 45: // loop_stmt: "while" "(" expr ")" block
#line 297 "src/parser.yy"
                                                     { yylhs.value.as < ast::Statement * > () = new ast::While(yystack_[2].value.as < ast::Expression * > (), yystack_[0].value.as < ast::StatementList * > (), yystack_[4].location); }
#line 1372 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 46: // if_stmt: "if" "(" expr ")" block
#line 301 "src/parser.yy"
                                                       { yylhs.value.as < ast::Statement * > () = new ast::If(yystack_[2].value.as < ast::Expression * > (), yystack_[0].value.as < ast::StatementList * > ()); }
#line 1378 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 47: // if_stmt: "if" "(" expr ")" block "else" block_or_if
#line 302 "src/parser.yy"
                                                       { yylhs.value.as < ast::Statement * > () = new ast::If(yystack_[4].value.as < ast::Expression * > (), yystack_[2].value.as < ast::StatementList * > (), yystack_[0].value.as < ast::StatementList * > ()); }
#line 1384 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 48: // block_or_if: block
#line 306 "src/parser.yy"
                             { yylhs.value.as < ast::StatementList * > () = yystack_[0].value.as < ast::StatementList * > (); }
#line 1390 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 49: // block_or_if: if_stmt
#line 307 "src/parser.yy"
                             { yylhs.value.as < ast::StatementList * > () = new ast::StatementList; yylhs.value.as < ast::StatementList * > ()->emplace_back(yystack_[0].value.as < ast::Statement * > ()); }
#line 1396 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 50: // assign_stmt: tuple_access_expr "=" expr
#line 312 "src/parser.yy"
                {
                  error(yystack_[2].location + yystack_[0].location, "Tuples are immutable once created. Consider creating a new tuple and assigning it instead.");
                  YYERROR;
                }
#line 1405 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 51: // assign_stmt: map "=" expr
#line 316 "src/parser.yy"
                                     { yylhs.value.as < ast::Statement * > () = new ast::AssignMapStatement(yystack_[2].value.as < ast::Map * > (), yystack_[0].value.as < ast::Expression * > (), false, yystack_[1].location); }
#line 1411 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 52: // assign_stmt: var "=" expr
#line 317 "src/parser.yy"
                                     { yylhs.value.as < ast::Statement * > () = new ast::AssignVarStatement(yystack_[2].value.as < ast::Variable * > (), yystack_[0].value.as < ast::Expression * > (), false, yystack_[1].location); }
#line 1417 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 53: // assign_stmt: map compound_op unary_expr
#line 319 "src/parser.yy"
                {
                  auto b = new ast::Binop(yystack_[2].value.as < ast::Map * > (), yystack_[1].value.as < int > (), yystack_[0].value.as < ast::Expression * > (), yystack_[1].location);
                  yylhs.value.as < ast::Statement * > () = new ast::AssignMapStatement(yystack_[2].value.as < ast::Map * > (), b, true, yylhs.location);
                }
#line 1426 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 54: // assign_stmt: var compound_op unary_expr
#line 324 "src/parser.yy"
                {
                  auto b = new ast::Binop(yystack_[2].value.as < ast::Variable * > (), yystack_[1].value.as < int > (), yystack_[0].value.as < ast::Expression * > (), yystack_[1].location);
                  yylhs.value.as < ast::Statement * > () = new ast::AssignVarStatement(yystack_[2].value.as < ast::Variable * > (), b, true, yylhs.location);
                }
#line 1435 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 55: // primary_expr: "identifier"
#line 331 "src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = new ast::Identifier(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1441 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 56: // primary_expr: int
#line 332 "src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Integer * > (); }
#line 1447 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 57: // primary_expr: "string"
#line 333 "src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = new ast::String(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1453 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 58: // primary_expr: "stack_mode"
#line 334 "src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = new ast::StackMode(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1459 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 59: // primary_expr: "builtin"
#line 335 "src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = new ast::Builtin(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1465 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 60: // primary_expr: "call_builtin"
#line 336 "src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = new ast::Builtin(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1471 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 61: // primary_expr: "(" expr ")"
#line 337 "src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = yystack_[1].value.as < ast::Expression * > (); }
#line 1477 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 62: // primary_expr: param
#line 338 "src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::PositionalParameter * > (); }
#line 1483 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 63: // primary_expr: map_or_var
#line 339 "src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1489 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 64: // primary_expr: "(" expr "," vargs ")"
#line 341 "src/parser.yy"
                {
                  auto args = new ast::ExpressionList;
                  args->emplace_back(yystack_[3].value.as < ast::Expression * > ());
                  args->insert(args->end(), yystack_[1].value.as < ast::ExpressionList * > ()->begin(), yystack_[1].value.as < ast::ExpressionList * > ()->end());
                  yylhs.value.as < ast::Expression * > () = new ast::Tuple(args, yylhs.location);
                }
#line 1500 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 65: // postfix_expr: primary_expr
#line 350 "src/parser.yy"
                                            { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1506 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 66: // postfix_expr: postfix_expr "." ident
#line 352 "src/parser.yy"
                                          { yylhs.value.as < ast::Expression * > () = new ast::FieldAccess(yystack_[2].value.as < ast::Expression * > (), yystack_[0].value.as < std::string > (), yystack_[1].location); }
#line 1512 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 67: // postfix_expr: postfix_expr "->" ident
#line 353 "src/parser.yy"
                                          { yylhs.value.as < ast::Expression * > () = new ast::FieldAccess(new ast::Unop(token::MUL, yystack_[2].value.as < ast::Expression * > (), yystack_[1].location), yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1518 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 68: // postfix_expr: tuple_access_expr
#line 355 "src/parser.yy"
                                          { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1524 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 69: // postfix_expr: postfix_expr "[" expr "]"
#line 357 "src/parser.yy"
                                          { yylhs.value.as < ast::Expression * > () = new ast::ArrayAccess(yystack_[3].value.as < ast::Expression * > (), yystack_[1].value.as < ast::Expression * > (), yystack_[2].location + yystack_[0].location); }
#line 1530 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 70: // postfix_expr: call
#line 358 "src/parser.yy"
                                          { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Call * > (); }
#line 1536 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 71: // postfix_expr: map_or_var "++"
#line 359 "src/parser.yy"
                                          { yylhs.value.as < ast::Expression * > () = new ast::Unop(token::INCREMENT, yystack_[1].value.as < ast::Expression * > (), true, yystack_[0].location); }
#line 1542 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 72: // postfix_expr: map_or_var "--"
#line 360 "src/parser.yy"
                                          { yylhs.value.as < ast::Expression * > () = new ast::Unop(token::DECREMENT, yystack_[1].value.as < ast::Expression * > (), true, yystack_[0].location); }
#line 1548 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 73: // postfix_expr: "++" ident
#line 362 "src/parser.yy"
                                          { error(yystack_[1].location, "The ++ operator must be applied to a map or variable"); YYERROR; }
#line 1554 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 74: // postfix_expr: "--" ident
#line 363 "src/parser.yy"
                                          { error(yystack_[1].location, "The -- operator must be applied to a map or variable"); YYERROR; }
#line 1560 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 75: // tuple_access_expr: postfix_expr "." "integer"
#line 368 "src/parser.yy"
                                          { yylhs.value.as < ast::Expression * > () = new ast::FieldAccess(yystack_[2].value.as < ast::Expression * > (), yystack_[0].value.as < long > (), yystack_[0].location); }
#line 1566 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 76: // unary_expr: unary_op cast_expr
#line 374 "src/parser.yy"
                                     { yylhs.value.as < ast::Expression * > () = new ast::Unop(yystack_[1].value.as < int > (), yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1572 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 77: // unary_expr: postfix_expr
#line 375 "src/parser.yy"
                                     { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1578 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 78: // unary_expr: "++" map_or_var
#line 376 "src/parser.yy"
                                     { yylhs.value.as < ast::Expression * > () = new ast::Unop(token::INCREMENT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1584 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 79: // unary_expr: "--" map_or_var
#line 377 "src/parser.yy"
                                     { yylhs.value.as < ast::Expression * > () = new ast::Unop(token::DECREMENT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1590 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 80: // unary_expr: ident "--"
#line 379 "src/parser.yy"
                                     { error(yystack_[1].location, "The -- operator must be applied to a map or variable"); YYERROR; }
#line 1596 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 81: // unary_expr: ident "++"
#line 380 "src/parser.yy"
                                     { error(yystack_[1].location, "The ++ operator must be applied to a map or variable"); YYERROR; }
#line 1602 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 82: // unary_op: "*"
#line 384 "src/parser.yy"
                       { yylhs.value.as < int > () = token::MUL; }
#line 1608 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 83: // unary_op: "~"
#line 385 "src/parser.yy"
                       { yylhs.value.as < int > () = token::BNOT; }
#line 1614 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 84: // unary_op: "!"
#line 386 "src/parser.yy"
                       { yylhs.value.as < int > () = token::LNOT; }
#line 1620 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 85: // unary_op: "-"
#line 387 "src/parser.yy"
                       { yylhs.value.as < int > () = token::MINUS; }
#line 1626 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 86: // expr: conditional_expr
#line 391 "src/parser.yy"
                                    { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1632 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 87: // conditional_expr: logical_or_expr
#line 395 "src/parser.yy"
                                                                 { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1638 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 88: // conditional_expr: logical_or_expr "?" expr ":" conditional_expr
#line 396 "src/parser.yy"
                                                                 { yylhs.value.as < ast::Expression * > () = new ast::Ternary(yystack_[4].value.as < ast::Expression * > (), yystack_[2].value.as < ast::Expression * > (), yystack_[0].value.as < ast::Expression * > (), yylhs.location); }
#line 1644 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 89: // logical_or_expr: logical_and_expr
#line 401 "src/parser.yy"
                                                     { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1650 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 90: // logical_or_expr: logical_or_expr "||" logical_and_expr
#line 402 "src/parser.yy"
                                                     { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::LOR, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1656 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 91: // logical_and_expr: or_expr
#line 406 "src/parser.yy"
                                              { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1662 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 92: // logical_and_expr: logical_and_expr "&&" or_expr
#line 407 "src/parser.yy"
                                              { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::LAND, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1668 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 93: // or_expr: xor_expr
#line 411 "src/parser.yy"
                                     { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1674 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 94: // or_expr: or_expr "|" xor_expr
#line 412 "src/parser.yy"
                                     { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::BOR, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1680 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 95: // xor_expr: and_expr
#line 416 "src/parser.yy"
                                       { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1686 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 96: // xor_expr: xor_expr "^" and_expr
#line 417 "src/parser.yy"
                                       { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::BXOR, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1692 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 97: // and_expr: equality_expr
#line 422 "src/parser.yy"
                                            { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1698 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 98: // and_expr: and_expr "&" equality_expr
#line 423 "src/parser.yy"
                                            { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::BAND, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1704 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 99: // equality_expr: relational_expr
#line 427 "src/parser.yy"
                                                 { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1710 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 100: // equality_expr: equality_expr "==" relational_expr
#line 428 "src/parser.yy"
                                                 { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::EQ, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1716 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 101: // equality_expr: equality_expr "!=" relational_expr
#line 429 "src/parser.yy"
                                                 { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::NE, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1722 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 102: // relational_expr: shift_expr
#line 433 "src/parser.yy"
                                              { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1728 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 103: // relational_expr: relational_expr "<=" shift_expr
#line 434 "src/parser.yy"
                                              { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::LE, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1734 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 104: // relational_expr: relational_expr ">=" shift_expr
#line 435 "src/parser.yy"
                                              { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::GE, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1740 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 105: // relational_expr: relational_expr "<" shift_expr
#line 436 "src/parser.yy"
                                              { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::LT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1746 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 106: // relational_expr: relational_expr ">" shift_expr
#line 437 "src/parser.yy"
                                              { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::GT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1752 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 107: // shift_expr: arith_expr
#line 441 "src/parser.yy"
                                            { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1758 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 108: // shift_expr: shift_expr "<<" arith_expr
#line 442 "src/parser.yy"
                                            { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::LEFT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1764 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 109: // shift_expr: shift_expr ">>" arith_expr
#line 443 "src/parser.yy"
                                            { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::RIGHT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1770 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 110: // arith_expr: cast_expr
#line 447 "src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1776 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 111: // arith_expr: arith_expr "+" cast_expr
#line 448 "src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::PLUS, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1782 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 112: // arith_expr: arith_expr "-" cast_expr
#line 449 "src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::MINUS, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1788 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 113: // arith_expr: arith_expr "*" cast_expr
#line 450 "src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::MUL, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1794 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 114: // arith_expr: arith_expr "/" cast_expr
#line 451 "src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::DIV, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1800 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 115: // arith_expr: arith_expr "%" cast_expr
#line 452 "src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), token::MOD, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1806 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 116: // cast_expr: unary_expr
#line 456 "src/parser.yy"
                                                      { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1812 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 117: // cast_expr: "(" "identifier" ")" cast_expr
#line 457 "src/parser.yy"
                                                      { yylhs.value.as < ast::Expression * > () = new ast::Cast(yystack_[2].value.as < std::string > (), false, false, yystack_[0].value.as < ast::Expression * > (), yystack_[3].location + yystack_[1].location); }
#line 1818 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 118: // cast_expr: "(" "identifier" "*" ")" cast_expr
#line 458 "src/parser.yy"
                                                      { yylhs.value.as < ast::Expression * > () = new ast::Cast(yystack_[3].value.as < std::string > (), true, false, yystack_[0].value.as < ast::Expression * > (), yystack_[4].location + yystack_[2].location); }
#line 1824 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 119: // cast_expr: "(" "identifier" "*" "*" ")" cast_expr
#line 459 "src/parser.yy"
                                                      { yylhs.value.as < ast::Expression * > () = new ast::Cast(yystack_[4].value.as < std::string > (), true, true, yystack_[0].value.as < ast::Expression * > (), yystack_[5].location + yystack_[3].location); }
#line 1830 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 120: // int: "-" "integer"
#line 463 "src/parser.yy"
                             { yylhs.value.as < ast::Integer * > () = new ast::Integer((long)(~(unsigned long)(yystack_[0].value.as < long > ()) + 1), yylhs.location); }
#line 1836 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 121: // int: "integer"
#line 464 "src/parser.yy"
                             { yylhs.value.as < ast::Integer * > () = new ast::Integer(yystack_[0].value.as < long > (), yylhs.location); }
#line 1842 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 122: // ident: "identifier"
#line 468 "src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 1848 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 123: // ident: "builtin"
#line 469 "src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 1854 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 124: // ident: "call"
#line 470 "src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 1860 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 125: // ident: "call_builtin"
#line 471 "src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 1866 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 126: // ident: "stack_mode"
#line 472 "src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 1872 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 127: // call: "call" "(" ")"
#line 476 "src/parser.yy"
                                             { yylhs.value.as < ast::Call * > () = new ast::Call(yystack_[2].value.as < std::string > (), yylhs.location); }
#line 1878 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 128: // call: "call" "(" vargs ")"
#line 477 "src/parser.yy"
                                             { yylhs.value.as < ast::Call * > () = new ast::Call(yystack_[3].value.as < std::string > (), yystack_[1].value.as < ast::ExpressionList * > (), yylhs.location); }
#line 1884 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 129: // call: "call_builtin" "(" ")"
#line 478 "src/parser.yy"
                                             { yylhs.value.as < ast::Call * > () = new ast::Call(yystack_[2].value.as < std::string > (), yylhs.location); }
#line 1890 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 130: // call: "call_builtin" "(" vargs ")"
#line 479 "src/parser.yy"
                                             { yylhs.value.as < ast::Call * > () = new ast::Call(yystack_[3].value.as < std::string > (), yystack_[1].value.as < ast::ExpressionList * > (), yylhs.location); }
#line 1896 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 131: // call: "identifier" "(" ")"
#line 480 "src/parser.yy"
                                             { error(yystack_[2].location, "Unknown function: " + yystack_[2].value.as < std::string > ()); YYERROR;  }
#line 1902 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 132: // call: "identifier" "(" vargs ")"
#line 481 "src/parser.yy"
                                             { error(yystack_[3].location, "Unknown function: " + yystack_[3].value.as < std::string > ()); YYERROR;  }
#line 1908 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 133: // call: "builtin" "(" ")"
#line 482 "src/parser.yy"
                                             { error(yystack_[2].location, "Unknown function: " + yystack_[2].value.as < std::string > ()); YYERROR;  }
#line 1914 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 134: // call: "builtin" "(" vargs ")"
#line 483 "src/parser.yy"
                                             { error(yystack_[3].location, "Unknown function: " + yystack_[3].value.as < std::string > ()); YYERROR;  }
#line 1920 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 135: // call: "stack_mode" "(" ")"
#line 484 "src/parser.yy"
                                             { error(yystack_[2].location, "Unknown function: " + yystack_[2].value.as < std::string > ()); YYERROR;  }
#line 1926 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 136: // call: "stack_mode" "(" vargs ")"
#line 485 "src/parser.yy"
                                             { error(yystack_[3].location, "Unknown function: " + yystack_[3].value.as < std::string > ()); YYERROR;  }
#line 1932 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 137: // map: "map"
#line 489 "src/parser.yy"
                                  { yylhs.value.as < ast::Map * > () = new ast::Map(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1938 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 138: // map: "map" "[" vargs "]"
#line 490 "src/parser.yy"
                                  { yylhs.value.as < ast::Map * > () = new ast::Map(yystack_[3].value.as < std::string > (), yystack_[1].value.as < ast::ExpressionList * > (), yylhs.location); }
#line 1944 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 139: // var: "variable"
#line 494 "src/parser.yy"
                    { yylhs.value.as < ast::Variable * > () = new ast::Variable(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1950 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 140: // map_or_var: var
#line 498 "src/parser.yy"
                    { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Variable * > (); }
#line 1956 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 141: // map_or_var: map
#line 499 "src/parser.yy"
                    { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Map * > (); }
#line 1962 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 142: // vargs: vargs "," expr
#line 503 "src/parser.yy"
                               { yylhs.value.as < ast::ExpressionList * > () = yystack_[2].value.as < ast::ExpressionList * > (); yystack_[2].value.as < ast::ExpressionList * > ()->push_back(yystack_[0].value.as < ast::Expression * > ()); }
#line 1968 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 143: // vargs: expr
#line 504 "src/parser.yy"
                               { yylhs.value.as < ast::ExpressionList * > () = new ast::ExpressionList; yylhs.value.as < ast::ExpressionList * > ()->push_back(yystack_[0].value.as < ast::Expression * > ()); }
#line 1974 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 144: // compound_op: "<<="
#line 508 "src/parser.yy"
                             { yylhs.value.as < int > () = token::LEFT; }
#line 1980 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 145: // compound_op: "&="
#line 509 "src/parser.yy"
                             { yylhs.value.as < int > () = token::BAND; }
#line 1986 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 146: // compound_op: "|="
#line 510 "src/parser.yy"
                             { yylhs.value.as < int > () = token::BOR; }
#line 1992 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 147: // compound_op: "^="
#line 511 "src/parser.yy"
                             { yylhs.value.as < int > () = token::BXOR; }
#line 1998 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 148: // compound_op: "/="
#line 512 "src/parser.yy"
                             { yylhs.value.as < int > () = token::DIV; }
#line 2004 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 149: // compound_op: "-="
#line 513 "src/parser.yy"
                             { yylhs.value.as < int > () = token::MINUS; }
#line 2010 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 150: // compound_op: "%="
#line 514 "src/parser.yy"
                             { yylhs.value.as < int > () = token::MOD; }
#line 2016 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 151: // compound_op: "*="
#line 515 "src/parser.yy"
                             { yylhs.value.as < int > () = token::MUL; }
#line 2022 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 152: // compound_op: "+="
#line 516 "src/parser.yy"
                             { yylhs.value.as < int > () = token::PLUS; }
#line 2028 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;

  case 153: // compound_op: ">>="
#line 517 "src/parser.yy"
                             { yylhs.value.as < int > () = token::RIGHT; }
#line 2034 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"
    break;


#line 2038 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"

            default:
              break;
            }
        }
#if YY_EXCEPTIONS
      catch (const syntax_error& yyexc)
        {
          YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
          error (yyexc);
          YYERROR;
        }
#endif // YY_EXCEPTIONS
      YY_SYMBOL_PRINT ("-> $$ =", yylhs);
      yypop_ (yylen);
      yylen = 0;

      // Shift the result of the reduction.
      yypush_ (YY_NULLPTR, YY_MOVE (yylhs));
    }
    goto yynewstate;


  /*--------------------------------------.
  | yyerrlab -- here on detecting error.  |
  `--------------------------------------*/
  yyerrlab:
    // If not already recovering from an error, report this error.
    if (!yyerrstatus_)
      {
        ++yynerrs_;
        context yyctx (*this, yyla);
        std::string msg = yysyntax_error_ (yyctx);
        error (yyla.location, YY_MOVE (msg));
      }


    yyerror_range[1].location = yyla.location;
    if (yyerrstatus_ == 3)
      {
        /* If just tried and failed to reuse lookahead token after an
           error, discard it.  */

        // Return failure if at end of input.
        if (yyla.kind () == symbol_kind::S_YYEOF)
          YYABORT;
        else if (!yyla.empty ())
          {
            yy_destroy_ ("Error: discarding", yyla);
            yyla.clear ();
          }
      }

    // Else will try to reuse lookahead token after shifting the error token.
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:
    /* Pacify compilers when the user code never invokes YYERROR and
       the label yyerrorlab therefore never appears in user code.  */
    if (false)
      YYERROR;

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    YY_STACK_PRINT ();
    goto yyerrlab1;


  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;   // Each real token shifted decrements this.
    // Pop stack until we find a state that shifts the error token.
    for (;;)
      {
        yyn = yypact_[+yystack_[0].state];
        if (!yy_pact_value_is_default_ (yyn))
          {
            yyn += symbol_kind::S_YYerror;
            if (0 <= yyn && yyn <= yylast_
                && yycheck_[yyn] == symbol_kind::S_YYerror)
              {
                yyn = yytable_[yyn];
                if (0 < yyn)
                  break;
              }
          }

        // Pop the current state because it cannot handle the error token.
        if (yystack_.size () == 1)
          YYABORT;

        yyerror_range[1].location = yystack_[0].location;
        yy_destroy_ ("Error: popping", yystack_[0]);
        yypop_ ();
        YY_STACK_PRINT ();
      }
    {
      stack_symbol_type error_token;

      yyerror_range[2].location = yyla.location;
      YYLLOC_DEFAULT (error_token.location, yyerror_range, 2);

      // Shift the error token.
      error_token.state = state_type (yyn);
      yypush_ ("Shifting", YY_MOVE (error_token));
    }
    goto yynewstate;


  /*-------------------------------------.
  | yyacceptlab -- YYACCEPT comes here.  |
  `-------------------------------------*/
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;


  /*-----------------------------------.
  | yyabortlab -- YYABORT comes here.  |
  `-----------------------------------*/
  yyabortlab:
    yyresult = 1;
    goto yyreturn;


  /*-----------------------------------------------------.
  | yyreturn -- parsing is finished, return the result.  |
  `-----------------------------------------------------*/
  yyreturn:
    if (!yyla.empty ())
      yy_destroy_ ("Cleanup: discarding lookahead", yyla);

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    YY_STACK_PRINT ();
    while (1 < yystack_.size ())
      {
        yy_destroy_ ("Cleanup: popping", yystack_[0]);
        yypop_ ();
      }

    return yyresult;
  }
#if YY_EXCEPTIONS
    catch (...)
      {
        YYCDEBUG << "Exception caught: cleaning lookahead and stack\n";
        // Do not try to display the values of the reclaimed symbols,
        // as their printers might throw an exception.
        if (!yyla.empty ())
          yy_destroy_ (YY_NULLPTR, yyla);

        while (1 < yystack_.size ())
          {
            yy_destroy_ (YY_NULLPTR, yystack_[0]);
            yypop_ ();
          }
        throw;
      }
#endif // YY_EXCEPTIONS
  }

  void
   Parser ::error (const syntax_error& yyexc)
  {
    error (yyexc.location, yyexc.what ());
  }

  /* Return YYSTR after stripping away unnecessary quotes and
     backslashes, so that it's suitable for yyerror.  The heuristic is
     that double-quoting is unnecessary unless the string contains an
     apostrophe, a comma, or backslash (other than backslash-backslash).
     YYSTR is taken from yytname.  */
  std::string
   Parser ::yytnamerr_ (const char *yystr)
  {
    if (*yystr == '"')
      {
        std::string yyr;
        char const *yyp = yystr;

        for (;;)
          switch (*++yyp)
            {
            case '\'':
            case ',':
              goto do_not_strip_quotes;

            case '\\':
              if (*++yyp != '\\')
                goto do_not_strip_quotes;
              else
                goto append;

            append:
            default:
              yyr += *yyp;
              break;

            case '"':
              return yyr;
            }
      do_not_strip_quotes: ;
      }

    return yystr;
  }

  std::string
   Parser ::symbol_name (symbol_kind_type yysymbol)
  {
    return yytnamerr_ (yytname_[yysymbol]);
  }



  //  Parser ::context.
   Parser ::context::context (const  Parser & yyparser, const symbol_type& yyla)
    : yyparser_ (yyparser)
    , yyla_ (yyla)
  {}

  int
   Parser ::context::expected_tokens (symbol_kind_type yyarg[], int yyargn) const
  {
    // Actual number of expected tokens
    int yycount = 0;

    int yyn = yypact_[+yyparser_.yystack_[0].state];
    if (!yy_pact_value_is_default_ (yyn))
      {
        /* Start YYX at -YYN if negative to avoid negative indexes in
           YYCHECK.  In other words, skip the first -YYN actions for
           this state because they are default actions.  */
        int yyxbegin = yyn < 0 ? -yyn : 0;
        // Stay within bounds of both yycheck and yytname.
        int yychecklim = yylast_ - yyn + 1;
        int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
        for (int yyx = yyxbegin; yyx < yyxend; ++yyx)
          if (yycheck_[yyx + yyn] == yyx && yyx != symbol_kind::S_YYerror
              && !yy_table_value_is_error_ (yytable_[yyx + yyn]))
            {
              if (!yyarg)
                ++yycount;
              else if (yycount == yyargn)
                return 0;
              else
                yyarg[yycount++] = YY_CAST (symbol_kind_type, yyx);
            }
      }

    if (yyarg && yycount == 0 && 0 < yyargn)
      yyarg[0] = symbol_kind::S_YYEMPTY;
    return yycount;
  }



  int
   Parser ::yy_syntax_error_arguments_ (const context& yyctx,
                                                 symbol_kind_type yyarg[], int yyargn) const
  {
    /* There are many possibilities here to consider:
       - If this state is a consistent state with a default action, then
         the only way this function was invoked is if the default action
         is an error action.  In that case, don't check for expected
         tokens because there are none.
       - The only way there can be no lookahead present (in yyla) is
         if this state is a consistent state with a default action.
         Thus, detecting the absence of a lookahead is sufficient to
         determine that there is no unexpected or expected token to
         report.  In that case, just report a simple "syntax error".
       - Don't assume there isn't a lookahead just because this state is
         a consistent state with a default action.  There might have
         been a previous inconsistent state, consistent state with a
         non-default action, or user semantic action that manipulated
         yyla.  (However, yyla is currently not documented for users.)
       - Of course, the expected token list depends on states to have
         correct lookahead information, and it depends on the parser not
         to perform extra reductions after fetching a lookahead from the
         scanner and before detecting a syntax error.  Thus, state merging
         (from LALR or IELR) and default reductions corrupt the expected
         token list.  However, the list is correct for canonical LR with
         one exception: it will still contain any token that will not be
         accepted due to an error action in a later state.
    */

    if (!yyctx.lookahead ().empty ())
      {
        if (yyarg)
          yyarg[0] = yyctx.token ();
        int yyn = yyctx.expected_tokens (yyarg ? yyarg + 1 : yyarg, yyargn - 1);
        return yyn + 1;
      }
    return 0;
  }

  // Generate an error message.
  std::string
   Parser ::yysyntax_error_ (const context& yyctx) const
  {
    // Its maximum.
    enum { YYARGS_MAX = 5 };
    // Arguments of yyformat.
    symbol_kind_type yyarg[YYARGS_MAX];
    int yycount = yy_syntax_error_arguments_ (yyctx, yyarg, YYARGS_MAX);

    char const* yyformat = YY_NULLPTR;
    switch (yycount)
      {
#define YYCASE_(N, S)                         \
        case N:                               \
          yyformat = S;                       \
        break
      default: // Avoid compiler warnings.
        YYCASE_ (0, YY_("syntax error"));
        YYCASE_ (1, YY_("syntax error, unexpected %s"));
        YYCASE_ (2, YY_("syntax error, unexpected %s, expecting %s"));
        YYCASE_ (3, YY_("syntax error, unexpected %s, expecting %s or %s"));
        YYCASE_ (4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
        YYCASE_ (5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
      }

    std::string yyres;
    // Argument number.
    std::ptrdiff_t yyi = 0;
    for (char const* yyp = yyformat; *yyp; ++yyp)
      if (yyp[0] == '%' && yyp[1] == 's' && yyi < yycount)
        {
          yyres += symbol_name (yyarg[yyi++]);
          ++yyp;
        }
      else
        yyres += *yyp;
    return yyres;
  }


  const signed char  Parser ::yypact_ninf_ = -121;

  const signed char  Parser ::yytable_ninf_ = -127;

  const short
   Parser ::yypact_[] =
  {
     105,   105,   105,   105,    78,  -121,  -121,  -121,  -121,  -121,
      84,  -121,    13,  -121,    59,  -121,  -121,  -121,   397,     9,
    -121,  -121,  -121,  -121,  -121,  -121,  -121,  -121,  -121,  -121,
    -121,  -121,  -121,  -121,  -121,  -121,  -121,  -121,  -121,   436,
      55,    29,    55,  -121,  -121,  -121,     6,    66,    41,    63,
    -121,   143,  -121,  -121,    65,  -121,  -121,    22,  -121,  -121,
     397,   141,  -121,    11,   134,   144,   133,   142,    77,    25,
     113,    -3,  -121,  -121,    50,  -121,  -121,  -121,    52,   137,
    -121,     1,    14,  -121,  -121,  -121,  -121,  -121,   202,   241,
     280,   319,   397,   358,   397,    75,    35,  -121,  -121,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,  -121,  -121,
    -121,  -121,   181,   182,   184,  -121,  -121,  -121,   195,   137,
     199,  -121,  -121,  -121,  -121,   198,  -121,   189,   495,   397,
       2,  -121,   397,  -121,  -121,    36,  -121,    73,  -121,    90,
    -121,   100,    17,  -121,   116,   206,  -121,  -121,  -121,   212,
     134,   144,   133,   142,    77,    25,    25,   113,   113,   113,
     113,    -3,    -3,  -121,  -121,  -121,  -121,  -121,   397,    -7,
     397,  -121,  -121,   137,   397,   397,  -121,  -121,  -121,  -121,
    -121,  -121,  -121,  -121,  -121,  -121,   475,   397,   475,  -121,
     397,   217,   139,  -121,   397,  -121,  -121,  -121,  -121,  -121,
    -121,   397,   218,    29,   220,   221,   222,  -121,  -121,  -121,
     397,  -121,  -121,  -121,  -121,   397,  -121,  -121,  -121,     9,
       9,     9,     9,  -121,   183,  -121,  -121,  -121,     3,  -121,
    -121,  -121
  };

  const unsigned char
   Parser ::yydefact_[] =
  {
       6,     6,     6,     6,     0,    25,     3,     4,     5,     1,
      25,     8,    27,    12,    13,     7,    10,    25,     0,     0,
      18,    22,    23,    29,    20,    21,    19,   123,   124,   125,
     122,    16,    15,    28,    17,   126,    24,    14,    11,     0,
       0,    85,     0,    82,    84,    83,    59,   124,    60,    55,
      57,   137,   139,   121,    58,    62,    65,    77,    68,   116,
       0,     0,    86,    87,    89,    91,    93,    95,    97,    99,
     102,   107,   110,    56,     0,    70,   141,   140,    63,    34,
       9,    55,     0,    73,    78,   120,    74,    79,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    76,    26,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    81,    80,
      71,    72,     0,     0,     0,    42,    41,    40,     0,    34,
      32,    38,    35,    36,    39,    68,    37,   141,   140,     0,
       0,    61,     0,   133,   143,     0,   127,     0,   129,     0,
     131,     0,     0,   135,     0,     0,    75,    66,    67,     0,
      90,    92,    94,    96,    98,   100,   101,   103,   104,   105,
     106,   108,   109,   111,   112,   113,   114,   115,     0,     0,
       0,    30,    33,    34,     0,     0,   144,   153,   152,   149,
     151,   148,   150,   145,   146,   147,     0,     0,     0,   117,
       0,     0,     0,   134,     0,   128,   130,   132,   138,   136,
      69,     0,     0,     0,     0,     0,     0,    31,    50,    51,
       0,    53,    52,    54,   118,     0,    64,   142,    88,     0,
       0,     0,     0,   119,    46,    44,    43,    45,     0,    48,
      49,    47
  };

  const short
   Parser ::yypgoto_[] =
  {
    -121,  -121,   179,  -121,   223,  -121,   219,  -121,  -121,   -10,
     -75,  -120,  -121,  -121,  -121,  -121,    -1,  -121,  -121,  -121,
    -121,   -78,   -84,  -121,   -18,    24,  -121,   138,   145,   150,
     136,   140,    39,    32,    62,   -57,    64,    -8,  -121,   -77,
     -74,   119,   -73,   107
  };

  const unsigned char
   Parser ::yydefgoto_[] =
  {
       0,     4,     5,    10,    11,    12,    13,    14,    19,    55,
      80,   128,   129,   130,   131,   132,   133,   241,   134,    56,
      57,    58,    59,    60,   144,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,   145,   196
  };

  const short
   Parser ::yytable_[] =
  {
      61,   135,   137,    97,    36,   138,    37,    23,    79,   182,
      91,   139,   200,    16,    79,    88,   147,   149,   151,   152,
     154,    82,    99,   113,   141,   208,    17,   142,  -122,    94,
     204,   213,    83,  -123,    86,   114,   100,   115,   116,   117,
    -122,   140,   201,   107,   108,  -123,   203,   109,   110,   204,
      90,   135,   137,   122,    18,   138,   173,   174,   175,   176,
     177,   136,    20,   217,    33,    53,    21,    22,  -125,   202,
      95,    96,    91,    23,    93,    89,   155,   118,     9,   120,
    -125,   159,   199,   205,    -2,    24,   204,   157,   158,   119,
    -122,   121,  -126,   105,   106,    27,    28,    29,    30,    25,
     206,    85,  -122,   204,  -126,   135,   137,    26,    35,   138,
     207,   136,   221,   204,   223,    27,    28,    29,    30,    27,
      28,    29,    30,    31,    51,    52,   209,    32,    35,   204,
      33,    34,    35,   111,   112,    27,    28,    29,    30,   167,
     168,   169,   170,   224,   165,   166,    39,   156,    35,   226,
      92,    23,   204,    98,   234,   235,   236,   237,   101,    84,
     212,    87,   216,   239,    40,   136,   218,   219,   233,   214,
       1,     2,     3,   171,   172,    41,    42,    43,   103,   222,
       6,     7,     8,    44,    45,   104,   227,   122,   102,   123,
     178,   179,   124,   180,   125,   126,   127,    46,    47,    48,
      49,   181,    82,   183,   185,    50,    51,    52,    33,    53,
      54,    39,   143,   184,   210,   211,    23,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   225,   229,    40,
     230,   231,   232,    15,   238,   228,    38,   240,   160,   163,
      41,    42,    43,   215,   164,   198,   161,     0,    44,    45,
      39,   146,   162,     0,     0,    23,     0,     0,     0,     0,
       0,     0,    46,    47,    48,    49,     0,     0,    40,     0,
      50,    51,    52,    33,    53,    54,     0,     0,     0,    41,
      42,    43,     0,     0,     0,     0,     0,    44,    45,    39,
     148,     0,     0,     0,    23,     0,     0,     0,     0,     0,
       0,    46,    47,    48,    49,     0,     0,    40,     0,    50,
      51,    52,    33,    53,    54,     0,     0,     0,    41,    42,
      43,     0,     0,     0,     0,     0,    44,    45,    39,   150,
       0,     0,     0,    23,     0,     0,     0,     0,     0,     0,
      46,    47,    48,    49,     0,     0,    40,     0,    50,    51,
      52,    33,    53,    54,     0,     0,     0,    41,    42,    43,
       0,     0,     0,     0,     0,    44,    45,    39,   153,     0,
       0,     0,    23,     0,     0,     0,     0,     0,     0,    46,
      47,    48,    49,     0,     0,    40,     0,    50,    51,    52,
      33,    53,    54,     0,     0,     0,    41,    42,    43,     0,
       0,     0,     0,     0,    44,    45,    39,     0,     0,     0,
       0,    23,     0,     0,     0,     0,     0,     0,    46,    47,
      48,    49,     0,     0,    40,     0,    50,    51,    52,    33,
      53,    54,     0,     0,     0,    41,    42,    43,     0,     0,
       0,     0,     0,    44,    45,    39,     0,     0,     0,     0,
      23,     0,     0,     0,     0,     0,     0,    46,    47,    48,
      49,     0,     0,    40,     0,    50,    51,    52,    33,    53,
      54,     0,     0,     0,    41,    42,    43,     0,     0,     0,
       0,     0,    44,    45,   220,     0,     0,     0,     0,    23,
       0,     0,     0,     0,     0,     0,    46,    47,    48,    81,
       0,     0,    40,     0,    50,    51,    52,    33,    53,    54,
     197,     0,     0,    41,    42,    43,     0,     0,     0,     0,
       0,    44,    45,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,     0,     0,    46,    47,    48,    49,     0,
       0,     0,     0,    50,    51,    52,    33,    53,    54
  };

  const short
   Parser ::yycheck_[] =
  {
      18,    79,    79,    60,    14,    79,    14,    14,     5,   129,
       9,    10,    10,     0,     5,     9,    89,    90,    91,    92,
      93,    39,    11,    26,    10,     8,    13,    13,    27,     7,
      13,    38,    40,    27,    42,    38,    25,    40,    41,    42,
      39,    40,    40,    18,    19,    39,    10,    22,    23,    13,
       9,   129,   129,    50,    41,   129,   113,   114,   115,   116,
     117,    79,     3,   183,    71,    72,     7,     8,    27,   142,
      48,    49,     9,    14,     9,     9,    94,    27,     0,    27,
      39,    99,   139,    10,     0,    26,    13,    95,    96,    39,
      27,    39,    27,    16,    17,    60,    61,    62,    63,    40,
      10,    72,    39,    13,    39,   183,   183,    48,    73,   183,
      10,   129,   196,    13,   198,    60,    61,    62,    63,    60,
      61,    62,    63,    64,    69,    70,    10,    68,    73,    13,
      71,    72,    73,    20,    21,    60,    61,    62,    63,   107,
     108,   109,   110,   200,   105,   106,     9,    72,    73,    10,
       7,    14,    13,    12,   229,   230,   231,   232,    24,    40,
     178,    42,   180,   238,    27,   183,   184,   185,   225,   179,
      65,    66,    67,   111,   112,    38,    39,    40,    45,   197,
       1,     2,     3,    46,    47,    43,   204,    50,    44,    52,
       9,     9,    55,     9,    57,    58,    59,    60,    61,    62,
      63,     6,   220,     4,    15,    68,    69,    70,    71,    72,
      73,     9,    10,    15,     8,     3,    14,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    10,    10,    27,
      10,    10,    10,    10,    51,   211,    17,   238,   100,   103,
      38,    39,    40,   179,   104,   138,   101,    -1,    46,    47,
       9,    10,   102,    -1,    -1,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    60,    61,    62,    63,    -1,    -1,    27,    -1,
      68,    69,    70,    71,    72,    73,    -1,    -1,    -1,    38,
      39,    40,    -1,    -1,    -1,    -1,    -1,    46,    47,     9,
      10,    -1,    -1,    -1,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    60,    61,    62,    63,    -1,    -1,    27,    -1,    68,
      69,    70,    71,    72,    73,    -1,    -1,    -1,    38,    39,
      40,    -1,    -1,    -1,    -1,    -1,    46,    47,     9,    10,
      -1,    -1,    -1,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      60,    61,    62,    63,    -1,    -1,    27,    -1,    68,    69,
      70,    71,    72,    73,    -1,    -1,    -1,    38,    39,    40,
      -1,    -1,    -1,    -1,    -1,    46,    47,     9,    10,    -1,
      -1,    -1,    14,    -1,    -1,    -1,    -1,    -1,    -1,    60,
      61,    62,    63,    -1,    -1,    27,    -1,    68,    69,    70,
      71,    72,    73,    -1,    -1,    -1,    38,    39,    40,    -1,
      -1,    -1,    -1,    -1,    46,    47,     9,    -1,    -1,    -1,
      -1,    14,    -1,    -1,    -1,    -1,    -1,    -1,    60,    61,
      62,    63,    -1,    -1,    27,    -1,    68,    69,    70,    71,
      72,    73,    -1,    -1,    -1,    38,    39,    40,    -1,    -1,
      -1,    -1,    -1,    46,    47,     9,    -1,    -1,    -1,    -1,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    60,    61,    62,
      63,    -1,    -1,    27,    -1,    68,    69,    70,    71,    72,
      73,    -1,    -1,    -1,    38,    39,    40,    -1,    -1,    -1,
      -1,    -1,    46,    47,     9,    -1,    -1,    -1,    -1,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    60,    61,    62,    63,
      -1,    -1,    27,    -1,    68,    69,    70,    71,    72,    73,
      15,    -1,    -1,    38,    39,    40,    -1,    -1,    -1,    -1,
      -1,    46,    47,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    -1,    -1,    60,    61,    62,    63,    -1,
      -1,    -1,    -1,    68,    69,    70,    71,    72,    73
  };

  const signed char
   Parser ::yystos_[] =
  {
       0,    65,    66,    67,    75,    76,    76,    76,    76,     0,
      77,    78,    79,    80,    81,    78,     0,    13,    41,    82,
       3,     7,     8,    14,    26,    40,    48,    60,    61,    62,
      63,    64,    68,    71,    72,    73,    83,   111,    80,     9,
      27,    38,    39,    40,    46,    47,    60,    61,    62,    63,
      68,    69,    70,    72,    73,    83,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,     5,
      84,    63,    98,   111,   115,    72,   111,   115,     9,     9,
       9,     9,     7,     9,     7,    48,    49,   109,    12,    11,
      25,    24,    44,    45,    43,    16,    17,    18,    19,    22,
      23,    20,    21,    26,    38,    40,    41,    42,    27,    39,
      27,    39,    50,    52,    55,    57,    58,    59,    85,    86,
      87,    88,    89,    90,    92,    95,    98,   113,   114,    10,
      40,    10,    13,    10,    98,   116,    10,   116,    10,   116,
      10,   116,   116,    10,   116,    98,    72,   111,   111,    98,
     101,   102,   103,   104,   105,   106,   106,   107,   107,   107,
     107,   108,   108,   109,   109,   109,   109,   109,     9,     9,
       9,     6,    85,     4,    15,    15,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,   117,    15,   117,   109,
      10,    40,   116,    10,    13,    10,    10,    10,     8,    10,
       8,     3,    98,    38,    83,   110,    98,    85,    98,    98,
       9,    96,    98,    96,   109,    10,    10,    98,    99,    10,
      10,    10,    10,   109,    84,    84,    84,    84,    51,    84,
      90,    91
  };

  const signed char
   Parser ::yyr1_[] =
  {
       0,    74,    75,    76,    76,    76,    76,    77,    77,    78,
      78,    79,    79,    80,    81,    81,    81,    81,    81,    81,
      81,    81,    81,    81,    81,    81,    82,    82,    83,    83,
      84,    85,    85,    85,    85,    86,    86,    87,    87,    87,
      88,    88,    88,    89,    89,    89,    90,    90,    91,    91,
      92,    92,    92,    92,    92,    93,    93,    93,    93,    93,
      93,    93,    93,    93,    93,    94,    94,    94,    94,    94,
      94,    94,    94,    94,    94,    95,    96,    96,    96,    96,
      96,    96,    97,    97,    97,    97,    98,    99,    99,   100,
     100,   101,   101,   102,   102,   103,   103,   104,   104,   105,
     105,   105,   106,   106,   106,   106,   106,   107,   107,   107,
     108,   108,   108,   108,   108,   108,   109,   109,   109,   109,
     110,   110,   111,   111,   111,   111,   111,   112,   112,   112,
     112,   112,   112,   112,   112,   112,   112,   113,   113,   114,
     115,   115,   116,   116,   117,   117,   117,   117,   117,   117,
     117,   117,   117,   117
  };

  const signed char
   Parser ::yyr2_[] =
  {
       0,     2,     2,     2,     2,     2,     0,     2,     1,     3,
       2,     3,     1,     1,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     0,     3,     0,     1,     1,
       3,     3,     1,     2,     0,     1,     1,     1,     1,     1,
       1,     1,     1,     5,     5,     5,     5,     7,     1,     1,
       3,     3,     3,     3,     3,     1,     1,     1,     1,     1,
       1,     3,     1,     1,     5,     1,     3,     3,     1,     4,
       1,     2,     2,     2,     2,     3,     2,     1,     2,     2,
       2,     2,     1,     1,     1,     1,     1,     1,     5,     1,
       3,     1,     3,     1,     3,     1,     3,     1,     3,     1,
       3,     3,     1,     3,     3,     3,     3,     1,     3,     3,
       1,     3,     3,     3,     3,     3,     1,     4,     5,     6,
       2,     1,     1,     1,     1,     1,     1,     3,     4,     3,
       4,     3,     4,     3,     4,     3,     4,     1,     4,     1,
       1,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1
  };


#if YYDEBUG || 1
  // YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
  // First, the terminals, then, starting at \a YYNTOKENS, nonterminals.
  const char*
  const  Parser ::yytname_[] =
  {
  "\"end of file\"", "error", "\"invalid token\"", "\":\"", "\";\"",
  "\"{\"", "\"}\"", "\"[\"", "\"]\"", "\"(\"", "\")\"", "\"?\"",
  "\"end predicate\"", "\",\"", "\"$#\"", "\"=\"", "\"==\"", "\"!=\"",
  "\"<=\"", "\">=\"", "\"<<\"", "\">>\"", "\"<\"", "\">\"", "\"&&\"",
  "\"||\"", "\"+\"", "\"++\"", "\"<<=\"", "\">>=\"", "\"+=\"", "\"-=\"",
  "\"*=\"", "\"/=\"", "\"%=\"", "\"&=\"", "\"|=\"", "\"^=\"", "\"-\"",
  "\"--\"", "\"*\"", "\"/\"", "\"%\"", "\"&\"", "\"|\"", "\"^\"", "\"!\"",
  "\"~\"", "\".\"", "\"->\"", "\"if\"", "\"else\"", "\"unroll\"",
  "\"struct\"", "\"union\"", "\"while\"", "\"for\"", "\"return\"",
  "\"continue\"", "\"break\"", "\"builtin\"", "\"call\"",
  "\"call_builtin\"", "\"identifier\"", "\"path\"",
  "\"preprocessor directive\"", "\"struct definition\"", "\"enum\"",
  "\"string\"", "\"map\"", "\"variable\"", "\"positional parameter\"",
  "\"integer\"", "\"stack_mode\"", "$accept", "program", "c_definitions",
  "probes", "probe", "attach_points", "attach_point", "attach_point_def",
  "pred", "param", "block", "stmt_list", "block_stmt", "expr_stmt",
  "jump_stmt", "loop_stmt", "if_stmt", "block_or_if", "assign_stmt",
  "primary_expr", "postfix_expr", "tuple_access_expr", "unary_expr",
  "unary_op", "expr", "conditional_expr", "logical_or_expr",
  "logical_and_expr", "or_expr", "xor_expr", "and_expr", "equality_expr",
  "relational_expr", "shift_expr", "arith_expr", "cast_expr", "int",
  "ident", "call", "map", "var", "map_or_var", "vargs", "compound_op", YY_NULLPTR
  };
#endif


#if YYDEBUG
  const short
   Parser ::yyrline_[] =
  {
       0,   158,   158,   162,   163,   164,   165,   169,   170,   174,
     184,   197,   198,   202,   206,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   232,   236,   237,   242,   253,
     257,   264,   265,   269,   270,   274,   275,   279,   280,   285,
     289,   290,   291,   295,   296,   297,   301,   302,   306,   307,
     311,   316,   317,   318,   323,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   350,   352,   353,   355,   357,
     358,   359,   360,   362,   363,   368,   374,   375,   376,   377,
     379,   380,   384,   385,   386,   387,   391,   395,   396,   401,
     402,   406,   407,   411,   412,   416,   417,   422,   423,   427,
     428,   429,   433,   434,   435,   436,   437,   441,   442,   443,
     447,   448,   449,   450,   451,   452,   456,   457,   458,   459,
     463,   464,   468,   469,   470,   471,   472,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   489,   490,   494,
     498,   499,   503,   504,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517
  };

  void
   Parser ::yy_stack_print_ () const
  {
    *yycdebug_ << "Stack now";
    for (stack_type::const_iterator
           i = yystack_.begin (),
           i_end = yystack_.end ();
         i != i_end; ++i)
      *yycdebug_ << ' ' << int (i->state);
    *yycdebug_ << '\n';
  }

  void
   Parser ::yy_reduce_print_ (int yyrule) const
  {
    int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    // Print the symbols being reduced, and their result.
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
               << " (line " << yylno << "):\n";
    // The symbols being reduced.
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
                       yystack_[(yynrhs) - (yyi + 1)]);
  }
#endif // YYDEBUG


#line 4 "src/parser.yy"
} //  bpftrace 
#line 2748 "/builddir/build/BUILD/bpftrace-0.13.0/redhat-linux-build/parser.tab.cc"

#line 520 "src/parser.yy"


void bpftrace::Parser::error(const location &l, const std::string &m)
{
  driver.error(l, m);
}
